Module org.apache.derby.tools
Package org.apache.derby.jdbc

## Class ClientXADataSource

- java.lang.Object
- - org.apache.derby.client.BasicClientDataSource
  - - org.apache.derby.jdbc.BasicClientDataSource40
    - - org.apache.derby.jdbc.ClientDataSource
      - - org.apache.derby.jdbc.ClientXADataSource

- All Implemented Interfaces:
    `Serializable`, `Wrapper`, `Referenceable`, `CommonDataSource`, `DataSource`, `XADataSource`, `org.apache.derby.client.ClientDataSourceInterface`, `org.apache.derby.client.ClientXADataSourceInterface`

      public class ClientXADataSource
      extends ClientDataSource
      implements org.apache.derby.client.ClientXADataSourceInterface

  This datasource is suitable for a client/server use of Derby, running on full Java SE 6 and higher, corresponding to JDBC 4.0 and higher.

  An XADataSource is a factory for XAConnection objects. It represents a RM in a DTP environment. An object that implements the XADataSource interface is typically registered with a JNDI service provider.

  ClientXADataSource automatically supports the correct JDBC specification version for the Java Virtual Machine's environment.

  - JDBC 4.2 - Java SE 8
  - JDBC 4.1 - Java SE 7
  - JDBC 4.0 - Java SE 6

  ClientXADataSource is serializable and referenceable.

  See ClientDataSource for DataSource properties.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `className__` |

    - ### Fields inherited from class org.apache.derby.client.BasicClientDataSource

      `CLEAR_TEXT_PASSWORD_SECURITY, ENCRYPTED_PASSWORD_SECURITY, ENCRYPTED_USER_AND_PASSWORD_SECURITY, propertyDefault_traceLevel, SSL_BASIC, SSL_OFF, SSL_PEER_AUTHENTICATION, STRONG_PASSWORD_SUBSTITUTE_SECURITY, TRACE_ALL, TRACE_CONNECTION_CALLS, TRACE_CONNECTS, TRACE_DIAGNOSTICS, TRACE_DRIVER_CONFIGURATION, TRACE_NONE, TRACE_PARAMETER_META_DATA, TRACE_PROTOCOL_FLOWS, TRACE_RESULT_SET_CALLS, TRACE_RESULT_SET_META_DATA, TRACE_STATEMENT_CALLS, TRACE_XA_CALLS, USER_ONLY_SECURITY`

    - ### Fields inherited from interface org.apache.derby.client.ClientDataSourceInterface

      `CLEAR_TEXT_PASSWORD_SECURITY, ENCRYPTED_PASSWORD_SECURITY, ENCRYPTED_USER_AND_PASSWORD_SECURITY, propertyDefault_portNumber, propertyDefault_retrieveMessageText, propertyDefault_securityMechanism, propertyDefault_serverName, propertyDefault_traceFileAppend, propertyDefault_user, STRONG_PASSWORD_SUBSTITUTE_SECURITY, USER_ONLY_SECURITY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ClientXADataSource()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ShardingKeyBuilder` | `createShardingKeyBuilder()` | Added by Java 9
    `XAConnection` | `getXAConnection()` |
    `XAConnection` | `getXAConnection​(String user, String password)` |

    - ### Methods inherited from class org.apache.derby.jdbc.ClientDataSource

      `getReference`

    - ### Methods inherited from class org.apache.derby.client.BasicClientDataSource

      `computeDncLogWriterForNewConnection, getClientSSLMode, getConnection, getConnection, getConnectionAttributes, getCreateDatabase, getDatabaseName, getDataSourceName, getDescription, getLoginTimeout, getLogWriter, getParentLogger, getPassword, getPassword, getPortNumber, getProperties, getRetrieveMessageText, getRetrieveMessageText, getSecurityMechanism, getSecurityMechanism, getSecurityMechanism, getServerName, getShutdownDatabase, getSsl, getSSLModeFromString, getTraceDirectory, getTraceDirectory, getTraceFile, getTraceFile, getTraceFileAppend, getTraceFileAppend, getTraceLevel, getTraceLevel, getUser, getUser, isWrapperFor, maxStatementsToPool, setConnectionAttributes, setCreateDatabase, setDatabaseName, setDataSourceName, setDescription, setLoginTimeout, setLogWriter, setPassword, setPortNumber, setRetrieveMessageText, setSecurityMechanism, setServerName, setShutdownDatabase, setSsl, setTraceDirectory, setTraceFile, setTraceFileAppend, setTraceLevel, setUser, tokenizeAttributes, unwrap`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.derby.client.ClientDataSourceInterface

      `getConnectionAttributes, getCreateDatabase, getDatabaseName, getDataSourceName, getDescription, getPassword, getPortNumber, getRetrieveMessageText, getSecurityMechanism, getSecurityMechanism, getServerName, getShutdownDatabase, getSsl, getTraceDirectory, getTraceFile, getTraceFileAppend, getTraceLevel, getUser, setConnectionAttributes, setCreateDatabase, setDatabaseName, setDataSourceName, setDescription, setPassword, setPortNumber, setRetrieveMessageText, setSecurityMechanism, setServerName, setShutdownDatabase, setSsl, setTraceDirectory, setTraceFile, setTraceFileAppend, setTraceLevel, setUser`

    - ### Methods inherited from interface javax.sql.CommonDataSource

      `getParentLogger`

    - ### Methods inherited from interface javax.sql.DataSource

      `createConnectionBuilder, getConnection, getConnection, getLoginTimeout, getLogWriter, setLoginTimeout, setLogWriter`

    - ### Methods inherited from interface java.sql.Wrapper

      `isWrapperFor, unwrap`

    - ### Methods inherited from interface javax.sql.XADataSource

      `createXAConnectionBuilder, getLoginTimeout, getLogWriter, setLoginTimeout, setLogWriter`

- - ### Field Detail

    - #### className__

          public static final String className__

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ClientXADataSource

          public ClientXADataSource()

  - ### Method Detail

    - #### getXAConnection

          public XAConnection getXAConnection()
                                       throws SQLException

      Specified by:
        `getXAConnection` in interface `XADataSource`
      Throws:
        `SQLException`

    - #### getXAConnection

          public XAConnection getXAConnection​(String user,
                                              String password)
                                       throws SQLException

      Specified by:
        `getXAConnection` in interface `XADataSource`
      Throws:
        `SQLException`

    - #### createShardingKeyBuilder

          public ShardingKeyBuilder createShardingKeyBuilder()
                                                      throws SQLException

      Added by Java 9
      Specified by:
        `createShardingKeyBuilder` in interface `org.apache.derby.client.ClientXADataSourceInterface`
      Specified by:
        `createShardingKeyBuilder` in interface `CommonDataSource`
      Throws:
        `SQLException`